#include "table.h"

#include <stdio.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include <X11/Xlib.h>

#include "tools.h"
#include "InputWindow.h"
#include "py.h"
#include "pyParser.h"

TABLE		*table;
INT8		iTableIMIndex=0;
INT8		iTableCount;

Bool            bTableDictLoaded=False;		//Ҫõʱٶ

RECORD       *currentRecord = NULL, *recordHead = NULL;
RECORD       *tableCandWord[MAX_CAND_WORD];
//unsigned int	iTableTotalCandCount;
INT8		iTableOrderChanged = 0;
char            strTableLegendSource[PHRASE_MAX_LENGTH * 2 + 1] = "";

FH		*fh;
int             iFH = 0;
unsigned int    iTableIndex = 0;

Bool            bIsTableDelPhrase = False;
HOTKEYS         hkTableDelPhrase[HOT_KEY_COUNT] = { CTRL_7, 0 };
Bool            bIsTableAdjustOrder = False;
HOTKEYS         hkTableAdjustOrder[HOT_KEY_COUNT] = { CTRL_6, 0 };
Bool            bIsTableAddPhrase = False;
HOTKEYS         hkTableAddPhrase[HOT_KEY_COUNT] = { CTRL_8, 0 };

INT8            iTableChanged = 0;
INT8            iTableNewPhraseHZCount;
Bool            bCanntFindCode;	//¼ɵĴܷʱ--һ¶ǿԵ
char            *strNewPhraseCode;

extern Display *dpy;
extern Window   inputWindow;

extern char     strCodeInput[];
extern Bool     bIsDoInputOnly;
extern int      iCandPageCount;
extern int      iCurrentCandPage;
extern int      iCandWordCount;
extern int      iLegendCandWordCount;
extern int      iLegendCandPageCount;
extern int      iCurrentLegendCandPage;
extern int      iCodeInputCount;
extern int      iMaxCandWord;
extern char     strStringGet[];
extern MESSAGE  messageUp[];
extern uint     uMessageUp;
extern MESSAGE  messageDown[];
extern uint     uMessageDown;

extern SINGLE_HZ hzLastInput[];
extern INT8     iHZLastInputCount;
extern INT8            iIMIndex;
extern Bool     bUseLegend;
extern Bool     bIsInLegend;
extern INT8     lastIsSingleHZ;
extern Bool     bDisablePagingInLegend;

//----------------------------------------
extern PYFA    *PYFAList;
extern PYCandWord PYCandWords[];
extern Bool     bSingleHZMode;
extern char     strFindString[];
extern ParsePYStruct findMap;
//----------------------------------------

/*
 * ȡ뷨   ļ·
 */
void LoadTableInfo( void)
{
    FILE *fp;
    char strPath[PATH_MAX];
    int i;
    char *pstr;
    
    
    FreeTableIM();
    if ( table )
    	free(table);
    iTableCount = 0;
    
    strcpy (strPath, (char *) getenv ("HOME"));
    strcat (strPath, "/.fcitx/");
    strcat (strPath, TABLE_CONFIG_FILENAME);

    if (access (strPath, 0)) {
        strcpy (strPath, PKGDATADIR "/data/");
	strcat (strPath, TABLE_CONFIG_FILENAME);
    }
    
    fp=fopen(strPath,"rt");
    if ( !fp )
    	return;

    //жٸ
    while (1) {
    	if (!fgets (strPath, PATH_MAX, fp))
            break;

        i = strlen (strPath) - 1;
        while (strPath[i] == ' ' || strPath[i] == '\n')
            strPath[i--] = '\0';
	
        pstr = strPath;
        if (*pstr == ' ')
            pstr++;
        if (pstr[0] == '#')
            continue;
	    
	if ( strstr(pstr,"[]") )
		iTableCount++;
    }
    
    table=(TABLE *)malloc(sizeof(TABLE)*iTableCount);
    for ( iTableIMIndex=0;iTableIMIndex<iTableCount;iTableIMIndex++) {
    	table[iTableIMIndex].strName[0]='\0';
	table[iTableIMIndex].strPath[0]='\0';
	table[iTableIMIndex].tableOrder = AD_NO;
	table[iTableIMIndex].bUsePY = True;
	table[iTableIMIndex].cPinyin='\0';
	table[iTableIMIndex].bTableAutoSendToClient=True;
	table[iTableIMIndex].bUseMatchingKey=False;
	table[iTableIMIndex].cMatchingKey='\0';
	table[iTableIMIndex].bTableExactMatch=False;
	table[iTableIMIndex].bPromptTableCode=True;
	table[iTableIMIndex].strSymbol[0]='\0';
    }
    
    iTableIMIndex = -1;
    //ȡԵĬֵ
    if ( iTableCount ) {
    	rewind(fp);
	
	while (1) {
	    if (!fgets (strPath, PATH_MAX, fp))
            	break;

	    i = strlen (strPath) - 1;
	    while (strPath[i] == ' ' || strPath[i] == '\n')
            	strPath[i--] = '\0';
	
	    pstr = strPath;
	    if (*pstr == ' ')
            	pstr++;
	    if (pstr[0] == '#')
            	continue;
	    
	    if ( !strcmp(pstr,"[]") ) {
	    	if ( iTableIMIndex!=-1 ) {
		    if ( table[iTableIMIndex].strName[0]=='\0' || table[iTableIMIndex].strPath[0]=='\0' ) {
		    	iTableCount = 0;
			free(table);
			fprintf(stderr,"%dļд޷\n",iTableIMIndex);
			return;
		    }
		}
	    	iTableIMIndex++;
	    }
	    else if (!strncmp(pstr,"=",5) ) {
	    	pstr+=5;
		strcpy(table[iTableIMIndex].strName,pstr);
	    }
	    else if ( !strncmp(pstr,"=",5) ) {
	    	pstr+=5;
		strcpy(table[iTableIMIndex].strPath,pstr);
	    }
	    else if ( !strncmp(pstr,"Ƶ=",5) ) {
	    	pstr+=5;
		table[iTableIMIndex].tableOrder = atoi(pstr);
	    }
	    else if ( !strncmp(pstr,"ƴ=",5) ) {
	    	pstr+=5;
		table[iTableIMIndex].bUsePY = atoi(pstr);
	    }
	    else if ( !strncmp(pstr,"ƴ=",7) ) {
	    	pstr+=7;
		while (*pstr==' ')
			pstr++;
		table[iTableIMIndex].cPinyin=*pstr;
	    }
	    else if ( !strncmp(pstr,"Զ=", 9) ) {
	    	pstr+=9;
		table[iTableIMIndex].bTableAutoSendToClient=atoi(pstr);
	    }
	    else if ( !strncmp(pstr,"ģ=",5) ) {
	    	pstr+=5;
		table[iTableIMIndex].bUseMatchingKey=atoi(pstr);
	    }
	    else if ( !strncmp(pstr,"ģ=",7) ) {
	    	pstr+=7;
		while (*pstr==' ')
			pstr++;
		table[iTableIMIndex].cMatchingKey=*pstr;
	    }
	    else if ( !strncmp(pstr,"ȷƥ=",9) ) {
	    	pstr+=9;
		table[iTableIMIndex].bTableExactMatch=atoi(pstr);
	    }
	    else if ( !strncmp(pstr,"ʾ=",9) ) {
	    	pstr+=9;
		table[iTableIMIndex].bPromptTableCode=atoi(pstr);
	    }
	    else if ( !strncmp(pstr,"=",5) ) {
	    	pstr+=5;
		strcpy(table[iTableIMIndex].strSymbol,pstr);
	    }
	}
    }
    
    table[iTableIMIndex].rule = NULL;
    
    fclose(fp);
}

Bool LoadTableDict (void)
{
    char            strCode[MAX_CODE_LENGTH + 1];
    char            strHZ[PHRASE_MAX_LENGTH * 2 + 1];
    FILE           *fpDict;
    RECORD	   *recTemp;
    char            strPath[PATH_MAX];
    unsigned int    i = 0;
    unsigned int    iTemp;

    //ȣǸõĸ
    for ( i=0; i<iTableCount; i++ ) {
    	if ( table[i].iIMIndex==iIMIndex )
		iTableIMIndex = i;
    }
    
    //
    strcpy (strPath, (char *) getenv ("HOME"));
    strcat (strPath, "/.fcitx/");
    strcat (strPath, table[iTableIMIndex].strPath);

    if (access (strPath, 0)) {
        strcpy (strPath, PKGDATADIR "/data/");
	strcat (strPath, table[iTableIMIndex].strPath);
    }
    
    fpDict = fopen (strPath, "rb");
    if (!fpDict) {
    	fprintf (stderr, "Cannot open table file: %s\n", strPath);
	return False;
    }

    //ȶȡϢ
    fread(&iTemp,sizeof(unsigned int),1,fpDict);
    table[iTableIMIndex].strInputCode=(char *)malloc(sizeof(char)*(iTemp+1));
    fread(table[iTableIMIndex].strInputCode,sizeof(char), iTemp+1,fpDict);
    fread(&(table[iTableIMIndex].iCodeLength),sizeof(unsigned char),1,fpDict);
    
    fread(&(table[iTableIMIndex].bRule), sizeof(unsigned char),1, fpDict);
    
    if ( table[iTableIMIndex].bRule ) {		//ʾʹ
    	table[iTableIMIndex].rule = (RULE *)malloc(sizeof(RULE)*(table[iTableIMIndex].iCodeLength-1));
	for ( i=0; i<table[iTableIMIndex].iCodeLength-1;i++ ) {		
		fread(&(table[iTableIMIndex].rule[i].iFlag),sizeof(unsigned char),1,fpDict);
		fread(&(table[iTableIMIndex].rule[i].iWords),sizeof(unsigned char),1,fpDict);
		table[iTableIMIndex].rule[i].rule=(RULE_RULE *)malloc(sizeof(RULE_RULE)*table[iTableIMIndex].iCodeLength);
		for ( iTemp=0; iTemp<table[iTableIMIndex].iCodeLength;iTemp++) {
			fread(&(table[iTableIMIndex].rule[i].rule[iTemp].iFlag),sizeof(unsigned char),1,fpDict);
			fread(&(table[iTableIMIndex].rule[i].rule[iTemp].iWhich),sizeof(unsigned char),1,fpDict);
			fread(&(table[iTableIMIndex].rule[i].rule[iTemp].iIndex),sizeof(unsigned char),1,fpDict);
		}
	}
    }
    
    recordHead = (RECORD *) malloc (sizeof (RECORD));
    currentRecord = recordHead;

    fread(&(table[iTableIMIndex].iRecordCount),sizeof(unsigned int),1,fpDict);
    for ( i=0; i<table[iTableIMIndex].iRecordCount; i++) {
    	fread(strCode, sizeof(char), table[iTableIMIndex].iCodeLength+1, fpDict);
	fread(&iTemp, sizeof(unsigned int), 1, fpDict);
	fread(strHZ, sizeof(char), iTemp, fpDict);
	
	recTemp = (RECORD *) malloc (sizeof (RECORD));	
	recTemp->strCode = (char *)malloc(sizeof(char)*(table[iTableIMIndex].iCodeLength+1));
	strcpy (recTemp->strCode, strCode);
	recTemp->strHZ = (char *) malloc (sizeof (char) * iTemp);
	strcpy (recTemp->strHZ, strHZ);
	recTemp->flag = 0;	
	
	fread(&(recTemp->iHit),sizeof(unsigned int),1,fpDict);
	fread(&(recTemp->iIndex),sizeof(unsigned int),1,fpDict);
	if ( recTemp->iIndex>iTableIndex )
		iTableIndex=recTemp->iIndex;
	
	currentRecord->next = recTemp;
	recTemp->prev = currentRecord;
	currentRecord = recTemp;
    }
    
    currentRecord->next = recordHead;
    recordHead->prev = currentRecord;
    
    fclose (fpDict);
    
    //ȡű
  /*  strcpy (strPath, (char *) getenv ("HOME"));
    strcat (strPath, "/.fcitx/");
    strcat (strPath, WUBI_FH_FILENAME);

    if (access (strPath, 0)) {
        strcpy (strPath, PKGDATADIR "/data/");
	strcat (strPath, WUBI_FH_FILENAME);
	fpDict = fopen (strPath, "rt");
    }

    fpDict = fopen (strPath, "rt");
    if (fpDict) {
	iFH = CalculateRecordNumber (fpDict);
	fh = (FH *) malloc (sizeof (FH) * iFH);

	for (i = 0; i < iFH; i++) {
	    if (EOF == fscanf (fpDict, "%s\n", fh[i].strFH))
		break;
	}
	iFH = i;

	fclose (fpDict);
    }
*/
    strNewPhraseCode=(char *)malloc(sizeof(char)*(table[iTableIMIndex].iCodeLength+1));
    strNewPhraseCode[table[iTableIMIndex].iCodeLength] = '\0';
    bTableDictLoaded=True;
    
    /* 
     * Ȼʼ뷨
    TableInit();
    */
    return True;
}

/*
 * ͷŵǰռõڴ
 * Ŀлʱʹռõڴ
 */
void FreeTableIM(void)
{
	RECORD	   *recTemp, *recNext;
	unsigned char	i;
	
	if ( !recordHead )
		return;
		
	if (iTableChanged || iTableOrderChanged)
		SaveTableDict ();
	
	recTemp=recordHead->next;	
	while ( recTemp!=recordHead ) {
		recNext=recTemp->next;
		
		free(recTemp->strCode);
		free(recTemp->strHZ);
		free(recTemp);
		
		recTemp=recNext;
	}
	
	free(recordHead);
	recordHead = NULL;
	
	free (table[iTableIMIndex].strInputCode);	
	table[iTableIMIndex].iRecordCount = 0;
	bTableDictLoaded = False;
	
	free (strNewPhraseCode);
	
	if ( table[iTableIMIndex].rule ) {
		for ( i=0; i<table[iTableIMIndex].iCodeLength-1; i++ )
			free(table[iTableIMIndex].rule[i].rule);
		free(table[iTableIMIndex].rule);
		
		table[iTableIMIndex].rule=NULL;
	}
}

void TableResetStatus (void)
{
    bIsTableAddPhrase = False;
    bIsTableDelPhrase = False;
    bIsTableAdjustOrder = False;
    bIsDoInputOnly = False;
}

void SaveTableDict (void)
{
    RECORD       *recTemp;
    char            strPath[PATH_MAX];
    FILE           *fpDict;
    unsigned int    iTemp;
    unsigned int    i;

    //
    strcpy (strPath, (char *) getenv ("HOME"));
    strcat (strPath, "/.fcitx/");    
    if (access (strPath, 0))
	mkdir (strPath, S_IRWXU);
    strcat (strPath, table[iTableIMIndex].strPath);
    fpDict = fopen (strPath, "wb");
    if (!fpDict) {
	fprintf (stderr, "Cannot create table file: %s\n", strPath);
	return;
    }

    iTemp=strlen(table[iTableIMIndex].strInputCode);
    fwrite(&iTemp,sizeof(unsigned int),1,fpDict);
    fwrite(table[iTableIMIndex].strInputCode,sizeof(char), iTemp+1,fpDict);
    fwrite(&(table[iTableIMIndex].iCodeLength),sizeof(INT8),1,fpDict);
    
    fwrite(&(table[iTableIMIndex].bRule), sizeof(unsigned char),1, fpDict);
    if ( table[iTableIMIndex].bRule ) {		//ʾʹ
    	for ( i=0; i<table[iTableIMIndex].iCodeLength-1;i++ ) {		
		fwrite(&(table[iTableIMIndex].rule[i].iFlag),sizeof(unsigned char),1,fpDict);
		fwrite(&(table[iTableIMIndex].rule[i].iWords),sizeof(unsigned char),1,fpDict);
		for ( iTemp=0; iTemp<table[iTableIMIndex].iCodeLength;iTemp++) {
			fwrite(&(table[iTableIMIndex].rule[i].rule[iTemp].iFlag),sizeof(unsigned char),1,fpDict);
			fwrite(&(table[iTableIMIndex].rule[i].rule[iTemp].iWhich),sizeof(unsigned char),1,fpDict);
			fwrite(&(table[iTableIMIndex].rule[i].rule[iTemp].iIndex),sizeof(unsigned char),1,fpDict);
		}
	}
    }
    
    fwrite(&(table[iTableIMIndex].iRecordCount),sizeof(unsigned int),1,fpDict);
    recTemp = recordHead->next;
    while (recTemp!=recordHead) {
    	fwrite(recTemp->strCode, sizeof(char), table[iTableIMIndex].iCodeLength+1, fpDict);
	iTemp=strlen(recTemp->strHZ)+1;
	fwrite(&iTemp, sizeof(unsigned int), 1, fpDict);	
	fwrite(recTemp->strHZ, sizeof(char), iTemp, fpDict);	
	fwrite(&(recTemp->iHit),sizeof(unsigned int),1,fpDict);
	fwrite(&(recTemp->iIndex),sizeof(unsigned int),1,fpDict);
	recTemp = recTemp->next;
    }
    
    fclose (fpDict);
    
    iTableOrderChanged = 0;
    iTableChanged = 0;
}

Bool IsInputKey(int iKey)
{
    char *p;
    
    p = table[iTableIMIndex].strInputCode;
    while (*p) {
    	if ( (char)iKey==*p)
		return True;
	p++;
    }
    
    return False;
}

INPUT_RETURN_VALUE DoTableInput (int iKey)
{
    INPUT_RETURN_VALUE retVal;

    if (!bTableDictLoaded)
	LoadTableDict ();
	
    retVal = IRV_DO_NOTHING;
    if (IsInputKey(iKey) || iKey == table[iTableIMIndex].cMatchingKey || iKey == table[iTableIMIndex].cPinyin) {
	bIsInLegend = False;
	
	if (!bIsTableAddPhrase && !bIsTableDelPhrase && !bIsTableAdjustOrder) {
	    if (strCodeInput[0] == table[iTableIMIndex].cPinyin) {
		if (iCodeInputCount != (MAX_PY_LENGTH + 1)) {
		    strCodeInput[iCodeInputCount++] = iKey;
		    strCodeInput[iCodeInputCount] = '\0';
		    retVal = TableGetCandWords (SM_FIRST);
		}
		else
		    retVal = IRV_DO_NOTHING;
	    }
	    else {
		if (iCodeInputCount < table[iTableIMIndex].iCodeLength) {
		    strCodeInput[iCodeInputCount++] = iKey;
		    strCodeInput[iCodeInputCount] = '\0';

		    if (iCodeInputCount == 1 && strCodeInput[0] == table[iTableIMIndex].cPinyin) {
			iCandWordCount = 0;	
			retVal = IRV_DISPLAY_CANDWORDS;
		    }
		    else {
			retVal = TableGetCandWords (SM_FIRST);
			if (table[iTableIMIndex].bTableAutoSendToClient && (iCodeInputCount == table[iTableIMIndex].iCodeLength)) {
			    if (iCandWordCount == 1) {	//ֻһѡʣ͵ͻ
				strcpy (strStringGet, TableGetCandWord (0));
				iCandWordCount = 0;
				retVal = IRV_GET_CANDWORDS;
			    }
			}
		    }
		}
		else {
		    if (table[iTableIMIndex].bTableAutoSendToClient) {
			if (iCandWordCount) {
			    strcpy (strStringGet, tableCandWord[0]->strHZ);
			    retVal = IRV_GET_CANDWORDS_NEXT;
			}
			else
			    retVal = IRV_DISPLAY_CANDWORDS;

			iCodeInputCount = 1;
			strCodeInput[0] = iKey;
			strCodeInput[1] = '\0';

			TableGetCandWords (SM_FIRST);
		    }
		    else
			retVal = IRV_DO_NOTHING;
		}
	    }
	}
    }
    else {
    	if (bIsTableAddPhrase) {
	    switch (iKey) {
	    case LEFT:
		if (iTableNewPhraseHZCount < iHZLastInputCount) {
		    iTableNewPhraseHZCount++;
		    TableCreateNewPhrase ();
		}
		break;
	    case RIGHT:
		if (iTableNewPhraseHZCount > 2) {
		    iTableNewPhraseHZCount--;
		    TableCreateNewPhrase ();
		}
		break;
	    case ENTER:
		if (!bCanntFindCode)
		    TableInsertPhrase (messageDown[1].strMsg, messageDown[0].strMsg);
	    case ESC:
		bIsTableAddPhrase = False;
		bIsDoInputOnly = False;
		return IRV_CLEAN;
	    default:
		return IRV_DO_NOTHING;
	    }

	    return IRV_DISPLAY_MESSAGE;
	}
	if (IsHotKey (iKey, hkTableAddPhrase)) {
	    if (!bIsTableAddPhrase) {
		if (iHZLastInputCount < 2 || !table[iTableIMIndex].bRule)	//Ϊ
		    return IRV_DO_NOTHING;

		iTableNewPhraseHZCount = 2;
		bIsTableAddPhrase = True;
		bIsDoInputOnly = True;

		uMessageUp = 1;
		strcpy (messageUp[0].strMsg, "/Ҽ/٣ENTERȷESCȡ");
		messageUp[0].type = MSG_TIPS;

		uMessageDown = 2;
		messageDown[0].type = MSG_FIRSTCAND;
		messageDown[1].type = MSG_CODE;

		TableCreateNewPhrase ();
		DisplayInputWindow ();

		retVal = IRV_DISPLAY_MESSAGE;
	    }
	    else
		retVal = IRV_TO_PROCESS;

	    return retVal;
	}

	if (!iCodeInputCount && !bIsInLegend)
	    return IRV_TO_PROCESS;

	if (iKey == ESC) {
	    if (bIsTableDelPhrase || bIsTableAdjustOrder) {
		TableResetStatus ();
		retVal = IRV_DISPLAY_CANDWORDS;
	    }
	    else
		return IRV_CLEAN;
	}
	else if (iKey >= '0' && iKey <= '9') {
	    if (!iCandWordCount)
		return IRV_TO_PROCESS;

	    iKey -= '0';
	    if (iKey == 0)
		iKey = 10;

	    if (!bIsInLegend) {
		if (iKey > iCandWordCount)
		    return IRV_DO_NOTHING;
		else {
		    if (bIsTableDelPhrase) {
			TableDelPhraseByIndex (iKey);
			retVal = TableGetCandWords (SM_FIRST);
		    }
		    else if (bIsTableAdjustOrder) {
			TableAdjustOrderByIndex (iKey);
			retVal = TableGetCandWords (SM_FIRST);
		    }
		    else {
			strcpy (strStringGet, TableGetCandWord (iKey - 1));
			if (bIsInLegend)
			    retVal = IRV_GET_LEGEND;
			else
			    retVal = IRV_GET_CANDWORDS;
		    }
		}
	    }
	    else {
		strcpy (strStringGet, TableGetLegendCandWord (iKey - 1));
		retVal = IRV_GET_LEGEND;
	    }
	}
	else if (!bIsTableDelPhrase && !bIsTableAdjustOrder) {
	    if (IsHotKey (iKey, hkTableAdjustOrder)) {
		if ((iCurrentCandPage == 0 && iCandWordCount < 2) || bIsInLegend)
		    return IRV_DO_NOTHING;

		bIsTableAdjustOrder = True;
		uMessageUp = 1;
		strcpy (messageUp[0].strMsg, "ѡҪǰĴţESCȡ");
		messageUp[0].type = MSG_TIPS;
		retVal = IRV_DISPLAY_MESSAGE;
	    }
	    else if (IsHotKey (iKey, hkTableDelPhrase)) {
		if (!iCandWordCount || bIsInLegend)
		    return IRV_DO_NOTHING;

		bIsTableDelPhrase = True;
		uMessageUp = 1;
		strcpy (messageUp[0].strMsg, "ѡҪɾĴţESCȡ");
		messageUp[0].type = MSG_TIPS;
		retVal = IRV_DISPLAY_MESSAGE;
	    }
	    else if (iKey == (XK_BackSpace & 0x00FF)) {
		if (!iCodeInputCount) {
		    bIsInLegend = False;
		    return IRV_DONOT_PROCESS_CLEAN;
		}

		iCodeInputCount--;
		strCodeInput[iCodeInputCount] = '\0';

		if (iCodeInputCount == 1 && strCodeInput[0] == table[iTableIMIndex].cPinyin) {
			iCandWordCount = 0;
		    retVal = IRV_DISPLAY_CANDWORDS;
		}
		else if (iCodeInputCount)
		    retVal = TableGetCandWords (SM_FIRST);
		else
		    retVal = IRV_CLEAN;
	    }
	    else if (iKey == ' ') {
		if (!bIsInLegend) {
		    if (!(iCodeInputCount == 1 && strCodeInput[0] == table[iTableIMIndex].cPinyin)) {
			if (!iCandWordCount) {
			    iCodeInputCount = 0;
			    return IRV_CLEAN;
			}
			strcpy (strStringGet, TableGetCandWord (0));
		    }
		    if (bIsInLegend)
			retVal = IRV_GET_LEGEND;
		    else
			retVal = IRV_GET_CANDWORDS;
		}
		else {
		    strcpy (strStringGet, TableGetLegendCandWord (0));
		    retVal = IRV_GET_LEGEND;
		}
	    }
	    else
		return IRV_TO_PROCESS;
	}
    }

    if (!bIsInLegend) {
	if (!bIsTableDelPhrase && !bIsTableAdjustOrder) {
	    if (iCodeInputCount) {
		uMessageUp = 1;
		strcpy (messageUp[0].strMsg, strCodeInput);
		messageUp[0].type = MSG_INPUT;
	    }
	    else
		uMessageUp = 0;
	}
	else
	    bIsDoInputOnly = True;
    }
    
    return retVal;
}

char           *TableGetCandWord (int iIndex)
{
    char           *pCandWord;

    if (!strcmp (strCodeInput, table[iTableIMIndex].strSymbol))
	return TableGetFHCandWord (iIndex);

    bIsInLegend = False;

    if (!iCandWordCount)
    	return NULL;
	
    if (iIndex > (iCandWordCount - 1))
	iIndex = iCandWordCount - 1;

    tableCandWord[iIndex]->iHit++;
    tableCandWord[iIndex]->iIndex=++iTableIndex;
	
    if ( table[iTableIMIndex].tableOrder!=AD_NO ) {
	iTableOrderChanged++;
	if ( iTableOrderChanged==TABLE_AUTO_SAVE_AFTER )
		SaveTableDict();
    }
	
    pCandWord = tableCandWord[iIndex]->strHZ;

    if (bUseLegend) {
    	strcpy (strTableLegendSource, tableCandWord[iIndex]->strHZ);
	TableGetLegendCandWords (SM_FIRST);
    }
    else {
     if (table[iTableIMIndex].bPromptTableCode) {
	    RECORD       *temp;

	    uMessageUp = 1;
	    strcpy (messageUp[0].strMsg, strCodeInput);
	    messageUp[0].type = MSG_INPUT;
	    
	    strcpy (messageDown[0].strMsg, pCandWord);
	    messageDown[0].type = MSG_TIPS;
	    temp = TableFindCode (pCandWord, False);
	    if (temp) {
		strcpy (messageDown[1].strMsg, temp->strCode);
		messageDown[1].type = MSG_CODE;
		uMessageDown = 2;
	    }
	    else
		uMessageDown = 1;
    	}
	else {
	    uMessageDown = 0;
	    uMessageUp = 0;
	    iCodeInputCount = 0;
	}
    }    

    if (strlen (pCandWord) == 2)
    	lastIsSingleHZ = 1;
    else
    	lastIsSingleHZ = 0;

    
    return pCandWord;
}

INPUT_RETURN_VALUE TableGetPinyinCandWords (SEARCH_MODE mode)
{
    int             i;
    RECORD       *pRec;

    if (mode == SM_FIRST) {
	bSingleHZMode = True;
	strcpy (strFindString, strCodeInput + 1);

	DoPYInput (-1);

	strCodeInput[0] = table[iTableIMIndex].cPinyin;
	strCodeInput[1] = '\0';

	strcat (strCodeInput, strFindString);
	iCodeInputCount = strlen (strCodeInput);
    }
    else
	PYGetCandWords (mode);

    //潫ƴĺѡֱתΪʵʽ
    for (i = 0; i < iCandWordCount; i++) {
	pRec = TableFindCode (PYFAList[PYCandWords[i].cand.base.iPYFA].pyBase[PYCandWords[i].cand.base.iBase].strHZ, False);
	if (pRec)
	    tableCandWord[i] = pRec;
	else
	    tableCandWord[i] = recordHead->next;
    }

    return IRV_DISPLAY_CANDWORDS;
}

INPUT_RETURN_VALUE TableGetCandWords (SEARCH_MODE mode)
{
    int             i;
    char            strTemp[2], *pstr;
    unsigned int    iTableTotalCandCount = 0;

    if (bIsInLegend)
	return TableGetLegendCandWords (mode);
    if (!strcmp (strCodeInput,table[iTableIMIndex].strSymbol))
	return TableGetFHCandWords (mode);
	
    if (strCodeInput[0] == table[iTableIMIndex].cPinyin && table[iTableIMIndex].bUsePY )
	TableGetPinyinCandWords (mode);
    else {
	if (mode == SM_FIRST) {
	    iCandPageCount = 0;
	    iCurrentCandPage = 0;
	    iTableTotalCandCount = 0;
	    TableResetFlags ();
	    if (TableFindFirstMatchCode () == -1) {
		iCandWordCount = 0;
		uMessageDown = 0;
		return IRV_DISPLAY_CANDWORDS;	//Not Found
	    }
	}
	else {
	    if (!iCandPageCount)
		return IRV_TO_PROCESS;

	    if (mode == SM_NEXT) {
		if (iCurrentCandPage == iCandPageCount)
		    return IRV_DO_NOTHING;

		iCurrentCandPage++;
	    }
	    else {
		if (!iCurrentCandPage)
		    return IRV_DO_NOTHING;
		    
		TableSetCandWordsFlag (iCandWordCount, False);
		iCurrentCandPage--;
	    }
	    
	    TableFindFirstMatchCode ();	
	}

	iCandWordCount = 0;	
	while ( currentRecord!=recordHead ) {
		if ( (mode==SM_PREV) ^ (!currentRecord->flag) ) {
			if (!TableCompareCode (strCodeInput, currentRecord->strCode) && CheckHZCharset (currentRecord->strHZ)) {
				if ( mode==SM_FIRST )
					iTableTotalCandCount++;
				if ( !TableAddCandWord(currentRecord,mode) )
					break;
			}
		}
		
		currentRecord = currentRecord->next;
	}
	
	TableSetCandWordsFlag (iCandWordCount,True);

	if ( table[iTableIMIndex].tableOrder == AD_NO ) {
		if ((currentRecord!=recordHead && currentRecord->next!=recordHead) && mode!=SM_PREV && iCurrentCandPage==iCandPageCount) {
			currentRecord = currentRecord->next;
			while (currentRecord!=recordHead) {
				if (!TableCompareCode (strCodeInput, currentRecord->strCode) && CheckHZCharset (currentRecord->strHZ)) { 
					iCandPageCount++;
					break;
				}
				currentRecord = currentRecord->next;
			}
		}
	}
	else if (mode == SM_FIRST)
		iCandPageCount = iTableTotalCandCount / iMaxCandWord - ((iTableTotalCandCount % iMaxCandWord )? 0:1);
	}
	
    	strTemp[1] = '\0';
    	uMessageDown = 0;

    	for (i = 0; i < iCandWordCount; i++) {
		strTemp[0] = i + 1 + '0';
		if (i == 9)
	    		strTemp[0] = '0';
		strcpy (messageDown[uMessageDown].strMsg, strTemp);
#ifdef _USE_XFT
		strcat (messageDown[uMessageDown].strMsg, " ");
#endif
		messageDown[uMessageDown++].type = MSG_INDEX;

		strcpy (messageDown[uMessageDown].strMsg, tableCandWord[i]->strHZ);
		messageDown[uMessageDown++].type = ((i == 0) ? MSG_FIRSTCAND : MSG_OTHER);
		if (HasMatchingKey () || strCodeInput[0]==table[iTableIMIndex].cPinyin)
	    		pstr = tableCandWord[i]->strCode;
		else
	    		pstr = tableCandWord[i]->strCode + iCodeInputCount;
		strcpy (messageDown[uMessageDown].strMsg, pstr);
		if (i != (iCandWordCount - 1)) {
#ifdef _USE_XFT
	    		strcat (messageDown[uMessageDown].strMsg, "  ");
#else
	    		strcat (messageDown[uMessageDown].strMsg, " ");
#endif
		}
		messageDown[uMessageDown++].type = MSG_CODE;
    	}

    	return IRV_DISPLAY_CANDWORDS;
}

Bool TableAddCandWord(RECORD *record, SEARCH_MODE mode)
{
	int i=0, j;
	
	switch ( table[iTableIMIndex].tableOrder ) {
		case AD_NO:
			if ( mode==SM_PREV ) {
				if ( iCandWordCount == iMaxCandWord )
					i = iCandWordCount -1;
				else
					i = iCandWordCount;
			}
			else {
				tableCandWord[iCandWordCount++]=record;
				if ( iCandWordCount == iMaxCandWord )
					return False;
				return True;
			}
			break;
			
		case AD_FREQ:
			if ( mode==SM_PREV ) {
				for ( i=iCandWordCount-1; i>=0; i-- ) {
					if ( strcmp(tableCandWord[i]->strCode,record->strCode)<0 || (strcmp(tableCandWord[i]->strCode,record->strCode)==0 && tableCandWord[i]->iHit>=record->iHit ))
						break;
				}
				
				if (iCandWordCount == iMaxCandWord) {
					if ( i<0 )
						return True;
				}
				else
					i++;
			}
			else {
				for ( ; i<iCandWordCount; i++) {
					if ( strcmp(tableCandWord[i]->strCode,record->strCode)>0 || (strcmp(tableCandWord[i]->strCode,record->strCode)==0 && tableCandWord[i]->iHit<record->iHit) )
						break;
				}
				if (i == iMaxCandWord)
					return True;
			}
			break;
		
		case AD_FAST:
			if ( mode==SM_PREV ) {
				for ( i=iCandWordCount-1; i>=0; i-- ) {
					if ( strcmp(tableCandWord[i]->strCode,record->strCode)<0 || (strcmp(tableCandWord[i]->strCode,record->strCode)==0 && tableCandWord[i]->iIndex>=record->iIndex ))
						break;
				}
				
				if (iCandWordCount == iMaxCandWord) {
					if ( i<0 )
						return True;
				}
				else
					i++;
			}
			else {
				for (i = 0; i < iCandWordCount; i++) {
					if ( strcmp(tableCandWord[i]->strCode,record->strCode)>0 || (strcmp(tableCandWord[i]->strCode,record->strCode)==0 && tableCandWord[i]->iIndex<record->iIndex) )
		    				break;
	    			}

				if (i == iMaxCandWord)
					return True;
			}
			break;
	}
	
    	if (mode == SM_PREV) {
		if (iCandWordCount == iMaxCandWord) {
	    		for (j = 0; j < i; j++)
				tableCandWord[j] = tableCandWord[j + 1];
		}
		else {
	    		for (j = iCandWordCount; j > i; j--)
				tableCandWord[j] = tableCandWord[j - 1];
		}
	}
	else {
		j = iCandWordCount;
		if (iCandWordCount == iMaxCandWord)
	    		j--;
		for (; j > i; j--)
			tableCandWord[j] = tableCandWord[j - 1];
    	}

    	tableCandWord[i] = record;
    	if (iCandWordCount != iMaxCandWord)
		iCandWordCount++;

    	return True;
}

void TableResetFlags (void)
{
	RECORD *record=recordHead->next;
	
	while ( record!=recordHead ) {
		record->flag=False;
		record=record->next;
	}
}

void TableSetCandWordsFlag (int iCount, Bool flag)
{
    int             i;

    for (i = 0; i < iCount; i++)
	tableCandWord[i]->flag=flag;
}

Bool HasMatchingKey (void)
{
    char           *str;

    str = strCodeInput;
    while (*str) {
	if (*str++ == table[iTableIMIndex].cMatchingKey)
	    return True;
    }

    return False;
}

int TableCompareCode (char *strUser, char *strDict)
{
    int             i;

    for (i = 0; i < strlen (strUser); i++) {
	if (!strDict[i])
	    return strUser[i];
	if (strUser[i] != table[iTableIMIndex].cMatchingKey || !table[iTableIMIndex].bUseMatchingKey) {
	    if (strUser[i] != strDict[i])
		return (strUser[i] - strDict[i]);
	}
    }

    if (table[iTableIMIndex].bTableExactMatch) {
	if (strlen (strUser) != strlen (strDict))
	    return -999;	//һֵ
    }

    return 0;
}

int TableFindFirstMatchCode (void)
{
    int             i = 0;

    if (!recordHead)
	return -1;

    currentRecord = recordHead->next;
    while (currentRecord != recordHead) {
	if (!TableCompareCode (strCodeInput, currentRecord->strCode)) {
	    if (CheckHZCharset (currentRecord->strHZ))
		return i;
	}
	currentRecord = currentRecord->next;
	i++;
    }

    return -1;			//Not found
}

/*
 * 
 * bMode=Trueʾʣʱһ
 */
RECORD       *TableFindCode (char *strHZ, Bool bMode)
{
    RECORD       *recTemp;

    if (!recordHead)
	return NULL;

    recTemp = recordHead->next;
    while (recTemp != recordHead) {
	if (!strcmp (recTemp->strHZ, strHZ)) {
	    if ((bMode && strlen (recTemp->strCode) > 2) || !bMode)
		return recTemp;
	}
	recTemp = recTemp->next;
    }

    return NULL;
}

/*
 * ŵ˳Ŵ1ʼ
 * ָ/ʵͬǰ
 */
void TableAdjustOrderByIndex (int iIndex)
{
    RECORD       *recTemp;

    recTemp = tableCandWord[iIndex - 1];
    while (!strcmp (recTemp->strCode, recTemp->prev->strCode))
	recTemp = recTemp->prev;
    if (recTemp == tableCandWord[iIndex - 1])	//˵Ѿǵһ
	return;

    //ָ/ʷŵrecTempǰ
    tableCandWord[iIndex - 1]->prev->next = tableCandWord[iIndex - 1]->next;
    tableCandWord[iIndex - 1]->next->prev = tableCandWord[iIndex - 1]->prev;
    recTemp->prev->next = tableCandWord[iIndex - 1];
    tableCandWord[iIndex - 1]->prev = recTemp->prev;
    recTemp->prev = tableCandWord[iIndex - 1];
    tableCandWord[iIndex - 1]->next = recTemp;

    iTableChanged++;
    if (iTableChanged == 5)
	SaveTableDict ();
}

/*
 * ɾ飬Ŵ1ʼ
 */
void TableDelPhraseByIndex (int iIndex)
{
    RECORD       *recTemp;

    if (strlen (tableCandWord[iIndex - 1]->strHZ) <= 2)
	return;

    recTemp = tableCandWord[iIndex - 1];

    recTemp->prev->next = recTemp->next;
    recTemp->next->prev = recTemp->prev;

    free (recTemp->strHZ);
    free (recTemp);
    
    table[iTableIMIndex].iRecordCount--;

    SaveTableDict ();
}

void TableInsertPhrase (char *strCode, char *strHZ)
{
    RECORD       *insertPoint, *dictNew, *recTemp;

    insertPoint = recordHead;
    recTemp = recordHead->next;

    while (recTemp != recordHead) {
	if (strcmp (recTemp->strCode, strCode) > 0) {
	    insertPoint = recTemp;
	    break;
	}
	else if (!strcmp (recTemp->strCode, strCode)) {
	    insertPoint = recTemp;
	    if (!strcmp (recTemp->strHZ, strHZ))	//ôѾڴʿ
		return;
	    break;
	}

	recTemp = recTemp->next;
    }

    dictNew = (RECORD *) malloc (sizeof (RECORD));
    dictNew->strCode=(char *)malloc(sizeof(char)*(table[iTableIMIndex].iCodeLength+1));
    strcpy (dictNew->strCode, strCode);
    dictNew->strHZ = (char *) malloc (sizeof (char) * strlen (strHZ) + 1);
    strcpy (dictNew->strHZ, strHZ);
    dictNew->iHit = 0;
    dictNew->iIndex = iTableIndex;
    
    dictNew->prev = insertPoint->prev;
    insertPoint->prev->next = dictNew;
    insertPoint->prev = dictNew;
    dictNew->next = insertPoint;

    table[iTableIMIndex].iRecordCount++;
	
    SaveTableDict ();	
}

void TableCreateNewPhrase (void)
{
    int             i;

    messageDown[0].strMsg[0] = '\0';
    for (i = iTableNewPhraseHZCount; i > 0; i--)
	strcat (messageDown[0].strMsg, hzLastInput[iHZLastInputCount - i].strHZ);

    TableCreatePhraseCode ();

    if (!bCanntFindCode)
	strcpy (messageDown[1].strMsg, strNewPhraseCode);
    else
	strcpy (messageDown[1].strMsg, "????");
}

void TableCreatePhraseCode (void)
{
    char           *str[table[iTableIMIndex].iCodeLength];
    unsigned char  i;
    unsigned char i1, i2;

    bCanntFindCode = False;
    
    if ( iTableNewPhraseHZCount>=table[iTableIMIndex].iCodeLength ) {
    	i2 = table[iTableIMIndex].iCodeLength;
	i1 = 1;
    }
    else {
    	i2 = iTableNewPhraseHZCount;
	i1 = 0;
    }
    
    for ( i=0; i<table[iTableIMIndex].iCodeLength-1; i++ ) {
    	if ( table[iTableIMIndex].rule[i].iWords==i2 && table[iTableIMIndex].rule[i].iFlag==i1 )
		break;
    }
    
    for ( i1=0; i1<table[iTableIMIndex].iCodeLength; i1++ ) {
    	if ( table[iTableIMIndex].rule[i].rule[i1].iFlag )
    		str[i1]=TableFindCode (hzLastInput[iHZLastInputCount - iTableNewPhraseHZCount + table[iTableIMIndex].rule[i].rule[i1].iWhich -1].strHZ, True)->strCode;
	else
		str[i1]=TableFindCode (hzLastInput[iHZLastInputCount - table[iTableIMIndex].rule[i].rule[i1].iWhich].strHZ, True)->strCode;
    
	if (str[i1])
    		strNewPhraseCode[i1]=str[i1][table[iTableIMIndex].rule[i].rule[i1].iIndex-1];
	else {
		bCanntFindCode=True;
		break;
	}
    }
}

/*
 * ȡѡб
 */
INPUT_RETURN_VALUE TableGetLegendCandWords (SEARCH_MODE mode)
{
    char            strTemp[2];
    int             iLength;
    int             i;
    RECORD         *tableLegend = NULL;
    unsigned int    iTableTotalLengendCandCount = 0;

    if (!strTableLegendSource[0])
	return IRV_TO_PROCESS;

    iLength = strlen (strTableLegendSource);
    
    if (mode == SM_FIRST) {
    	iCurrentLegendCandPage = 0;
	iLegendCandPageCount = 0;    
	TableResetFlags();
    }
    else {
	if (!iLegendCandPageCount)
	    return IRV_TO_PROCESS;

	if (mode == SM_NEXT) {
	    if (iCurrentLegendCandPage == iLegendCandPageCount)
		return IRV_DO_NOTHING;
		
	    iCurrentLegendCandPage++;
	}
	else {
	    if (!iCurrentLegendCandPage)
		return IRV_DO_NOTHING;

	    TableSetCandWordsFlag (iLegendCandWordCount,False);
	    iCurrentLegendCandPage--;
	}
    }
    
    iLegendCandWordCount = 0;
    tableLegend = recordHead->next;
    while ( tableLegend!=recordHead ) {
    	if ( ((mode==SM_PREV) ^ (!tableLegend->flag)) && ((iLength + 2) == strlen (tableLegend->strHZ))) {
		if (!strncmp (tableLegend->strHZ, strTableLegendSource, iLength) && tableLegend->strHZ[iLength] && CheckHZCharset (tableLegend->strHZ)) {
			if ( mode==SM_FIRST )
				iTableTotalLengendCandCount++;
			if ( !TableAddLegendCandWord(tableLegend,mode) )
				break;
		}
	}
		
	tableLegend = tableLegend->next;
    }
	
    TableSetCandWordsFlag (iLegendCandWordCount,True);

    if (mode == SM_FIRST && bDisablePagingInLegend)
	iLegendCandPageCount = iTableTotalLengendCandCount / iMaxCandWord - ((iTableTotalLengendCandCount % iMaxCandWord )? 0:1);

    uMessageUp = 2;
    strcpy (messageUp[0].strMsg, "룺");
    messageUp[0].type = MSG_TIPS;
    strcpy (messageUp[1].strMsg, strTableLegendSource);
    messageUp[1].type = MSG_INPUT;

    strTemp[1] = '\0';
    uMessageDown = 0;
    for (i = 0; i < iLegendCandWordCount; i++) {
	strTemp[0] = i + 1 + '0';
	if (i == 9)
	    strTemp[0] = '0';
	strcpy (messageDown[uMessageDown].strMsg, strTemp);
#ifdef _USE_XFT
	strcat (messageDown[uMessageDown].strMsg, " ");
#endif
	messageDown[uMessageDown++].type = MSG_INDEX;

	strcpy (messageDown[uMessageDown].strMsg, tableCandWord[i]->strHZ+strlen(strTableLegendSource));
	if (i != (iLegendCandWordCount - 1)) {
#ifdef _USE_XFT
	    strcat (messageDown[uMessageDown].strMsg, "  ");
#else
	    strcat (messageDown[uMessageDown].strMsg, " ");
#endif
	}
	messageDown[uMessageDown++].type = ((i == 0) ? MSG_FIRSTCAND : MSG_OTHER);
    }

    bIsInLegend = (iLegendCandWordCount != 0);

    return IRV_DISPLAY_CANDWORDS;
}

Bool TableAddLegendCandWord(RECORD *record, SEARCH_MODE mode)
{
	int i, j;
	
	if ( mode==SM_PREV ) {
		for ( i=iLegendCandWordCount-1; i>=0; i-- ) {
			if ( tableCandWord[i]->iHit>=record->iHit )
				break;
		}
				
		if (iLegendCandWordCount == iMaxCandWord) {
			if ( i<0 )
				return True;
		}
		else
			i++;
	}
	else {
		for ( i=0; i<iLegendCandWordCount; i++) {
			if ( tableCandWord[i]->iHit<record->iHit )
				break;
		}
		if (i == iMaxCandWord)
			return True;
	}
	
    	if (mode == SM_PREV) {
		if (iLegendCandWordCount == iMaxCandWord) {
	    		for (j = 0; j < i; j++)
				tableCandWord[j]=tableCandWord[j + 1];
		}
		else {
	    		for (j = iLegendCandWordCount; j > i; j--)
				tableCandWord[j]=tableCandWord[j - 1];
		}
	}
	else {
		j = iLegendCandWordCount;
		if (iLegendCandWordCount == iMaxCandWord)
	    		j--;
		for (; j > i; j--)
			tableCandWord[j]=tableCandWord[j - 1];
    	}

    	tableCandWord[i]=record;
    	if (iLegendCandWordCount != iMaxCandWord)
		iLegendCandWordCount++;

    	return True;
}

char           *TableGetLegendCandWord (int iIndex)
{
    if (iLegendCandWordCount) {
	if (iIndex > (iLegendCandWordCount - 1))
	    iIndex = iLegendCandWordCount - 1;
	
	tableCandWord[iIndex]->iHit++;
	strcpy (strTableLegendSource, tableCandWord[iIndex]->strHZ+strlen(strTableLegendSource));
	TableGetLegendCandWords (SM_FIRST);

	return strTableLegendSource;
    }

    return NULL;
}

INPUT_RETURN_VALUE TableGetFHCandWords (SEARCH_MODE mode)
{
    char            strTemp[2];
    int             i;

    if (!iFH)
	return IRV_DO_NOTHING;

    strTemp[1] = '\0';
    uMessageDown = 0;

    if (mode == SM_FIRST) {
	iCandPageCount = iFH / iMaxCandWord - ((iFH % iMaxCandWord) ? 0 : 1);
	iCurrentCandPage = 0;
    }
    else {
	if (!iCandPageCount)
	    return IRV_TO_PROCESS;

	if (mode == SM_NEXT) {
	    if (iCurrentCandPage == iCandPageCount)
		return IRV_DO_NOTHING;

	    iCurrentCandPage++;
	}
	else {
	    if (!iCurrentCandPage)
		return IRV_DO_NOTHING;

	    iCurrentCandPage--;
	}
    }

    for (i = 0; i < iMaxCandWord; i++) {
	strTemp[0] = i + 1 + '0';
	if (i == 9)
	    strTemp[0] = '0';
	strcpy (messageDown[uMessageDown].strMsg, strTemp);
// #ifdef _USE_XFT
	strcat (messageDown[uMessageDown].strMsg, ".");
// #endif
	messageDown[uMessageDown++].type = MSG_INDEX;
	strcpy (messageDown[uMessageDown].strMsg, fh[iCurrentCandPage * iMaxCandWord + i].strFH);
	if (i != (iMaxCandWord - 1)) {
#ifdef _USE_XFT
	    strcat (messageDown[uMessageDown].strMsg, "  ");
#else
	    strcat (messageDown[uMessageDown].strMsg, " ");
#endif
	}
	messageDown[uMessageDown++].type = ((i == 0) ? MSG_FIRSTCAND : MSG_OTHER);
	if ((iCurrentCandPage * iMaxCandWord + i) >= (iFH - 1)) {
	    i++;
	    break;
	}
    }

    iCandWordCount = i;
    return IRV_DISPLAY_CANDWORDS;
}

char           *TableGetFHCandWord (int iIndex)
{
    if (iCandWordCount) {
	if (iIndex > (iCandWordCount - 1))
	    iIndex = iCandWordCount - 1;

	return fh[iCurrentCandPage * iMaxCandWord + iIndex].strFH;
    }

    return NULL;
}

Bool TablePhraseTips (char *strPhrase)
{
    RECORD       *recTemp = NULL;
    INT8            i;

    if (!recordHead)
	return False;

    //һ飬ͲҪ
    if (lastIsSingleHZ != 1)
	return False;

    //strPhraseֻһ֣ҲҪ
    if (strlen (strPhrase) < 4)
	return False;

    //ҪжǲѾڴʿ
    for (i = 0; i < (strlen (strPhrase) - 2); i += 2) {
	recTemp = recordHead->next;
	while (recTemp != recordHead) {
	    if (!strcmp (recTemp->strHZ, strPhrase + i))
		goto _HIT;
	    recTemp = recTemp->next;
	}
    }
    if (recTemp == recordHead)
	return False;

  _HIT:
    strcpy (messageUp[0].strMsg, "ʿд ");
    messageUp[0].type = MSG_TIPS;
    strcpy (messageUp[1].strMsg, strPhrase + i);
    messageUp[1].type = MSG_INPUT;
    uMessageUp = 2;

    strcpy (messageDown[0].strMsg, "Ϊ");
    messageDown[0].type = MSG_TIPS;
    strcpy (messageDown[1].strMsg, recTemp->strCode);
    messageDown[1].type = MSG_CODE;
    uMessageDown = 2;

    return True;
}
