#ifndef _TABLE_H
#define _TABLE_H

#include <X11/Xlib.h>
#include <limits.h>
    
#include "ime.h"
    
#define TABLE_CONFIG_FILENAME	"tables.conf"
    
#define	MAX_CODE_LENGTH		12
#define PHRASE_MAX_LENGTH	10
#define FH_MAX_LENGTH		10
#define TABLE_AUTO_SAVE_AFTER	48

typedef struct _RULE_RULE 
 {
    
unsigned char  iFlag;	// 1 -->    0 --> 
    unsigned char   iWhich;	//ڼ
    unsigned char   iIndex;	//ڼ
} RULE_RULE;


typedef struct _RULE 
 {
    
unsigned char  iWords;	//ٸ
    unsigned char   iFlag;	//1 --> ڵiWords  0 --> iWords
    RULE_RULE      *rule;
               
} RULE;


typedef struct _TABLE {
    
char           strPath[PATH_MAX];
                   
 
 char strName[MAX_IM_NAME + 1];
                   
 char *strInputCode;
                   
 unsigned char iCodeLength;
                   
 char cMatchingKey;
                   
 char strSymbol[MAX_CODE_LENGTH + 1];
                   
 char cPinyin;
                   
 
 unsigned char bRule;
                   
 RULE * rule;	//ʹ
                   
 INT8 iIMIndex;	//¼Ӧ뷨˳
                   
 unsigned int iRecordCount;
                   
 ADJUSTORDER tableOrder;
                   
 Bool bUsePY;	//ʹƴ
    Bool            bTableAutoSendToClient;	//Զ
    Bool            bUseMatchingKey;	//Ƿģƥ
    Bool            bTableExactMatch;	//Ƿֻʾȷƥĺѡ/
    Bool            bPromptTableCode;	//ϺǷʾ--ʹƴʱʾ
} TABLE;


typedef struct _RECORD 
 {
    
char          *strCode;
                   
 char *strHZ;
                   
 struct _RECORD *next;
                   
struct _RECORD *prev;
                   
unsigned int iHit;
                   
 unsigned int iIndex;
                   
 unsigned int flag:1;
               
} RECORD;


typedef struct _FH 
 {
    
char           strFH[FH_MAX_LENGTH * 2 + 1];
               
} FH;


void          LoadTableInfo (void);

Bool LoadTableDict (void);

void           FreeTableIM (void);

void           SaveTableDict (void);

Bool IsInputKey (int iKey);

INPUT_RETURN_VALUE DoTableInput (int iKey);


INPUT_RETURN_VALUE TableGetCandWords (SEARCH_MODE mode);

Bool TableAddCandWord (RECORD * wbRecord, SEARCH_MODE mode);

INPUT_RETURN_VALUE TableGetLegendCandWords (SEARCH_MODE mode);

Bool TableAddLegendCandWord (RECORD * record, SEARCH_MODE mode);

INPUT_RETURN_VALUE TableGetFHCandWords (SEARCH_MODE mode);

INPUT_RETURN_VALUE TableGetPinyinCandWords (SEARCH_MODE mode);

void           TableResetStatus (void);

char          *TableGetLegendCandWord (int iIndex);

char          *TableGetFHCandWord (int iIndex);

Bool HasMatchingKey (void);

int            TableCompareCode (char *strUser, char *strDict);

int            TableFindFirstMatchCode (void);

RECORD * TableFindCode (char *strHZ, Bool bMode);

void           TableAdjustOrderByIndex (int iIndex);

void           TableDelPhraseByIndex (int iIndex);

void           TableInsertPhrase (char *strCode, char *strHZ);

char          *TableGetCandWord (int iIndex);

void           TableCreateNewPhrase (void);

void           TableCreatePhraseCode (void);


Bool TablePhraseTips (char *strPhrase);

void           TableSetCandWordsFlag (int iCount, Bool flag);

void           TableResetFlags (void);



#endif	/* 
 */
